import apiClient from '../apiClient';
// Asegúrate que las rutas a los DTOs sean correctas
import type { PermisoDto } from '../../models/dtos/Usuarios/PermisoDto';
import type { CreatePermisoDto } from '../../models/dtos/Usuarios/CreatePermisoDto.ts';
import type { UpdatePermisoDto } from '../../models/dtos/Usuarios/UpdatePermisoDto';

const getAllPermisos = async (moduloFilter?: string, codAccFilter?: string): Promise<PermisoDto[]> => {
    const params: Record<string, string> = {};
    if (moduloFilter) params.modulo = moduloFilter;
    if (codAccFilter) params.codAcc = codAccFilter;

    const response = await apiClient.get<PermisoDto[]>('/permisos', { params });
    return response.data;
};

const getPermisoById = async (id: number): Promise<PermisoDto> => {
    const response = await apiClient.get<PermisoDto>(`/permisos/${id}`);
    return response.data;
};

const createPermiso = async (data: CreatePermisoDto): Promise<PermisoDto> => {
    const response = await apiClient.post<PermisoDto>('/permisos', data);
    return response.data;
};

const updatePermiso = async (id: number, data: UpdatePermisoDto): Promise<void> => {
    await apiClient.put(`/permisos/${id}`, data);
};

const deletePermiso = async (id: number): Promise<void> => {
    await apiClient.delete(`/permisos/${id}`);
};

const permisoService = {
    getAllPermisos,
    getPermisoById,
    createPermiso,
    updatePermiso,
    deletePermiso,
};

export default permisoService;